# This file was auto-generated by Fern from our API Definition.

from .environment import BelvoEnvironment
from .errors import (
    BadRequestError,
    ForbiddenError,
    InternalServerError,
    NotFoundError,
    PreconditionError,
    RequestTimeoutError,
    UnauthorizedError,
)
from .resources import (
    accounts,
    balances,
    bank_accounts,
    categorization,
    customers,
    employment_records,
    income_verification,
    incomes,
    institutions,
    investment_portfolios,
    invoices,
    links,
    owners,
    payment_institutions,
    payment_intents,
    payment_links,
    payment_transactions,
    payment_webhooks,
    receivable_transactions,
    recurring_expenses,
    risk_insights,
    secret_keys,
    tax_compliance_status,
    tax_declarations,
    tax_retentions,
    tax_returns,
    tax_status,
    transactions,
)
from .types import (
    AccessToResourceDenied,
    Account,
    AccountsBalance,
    AccountsCreditData,
    AccountsFundsData,
    AccountsFundsDataPublicIdentifications,
    AccountsLoanData,
    AccountsLoanDataFees,
    AccountsLoanDataInterestRate,
    AccountsPaginatedResponse,
    AccountsReceivablesData,
    AnnualCostsAndDeductionsStatementBusiness,
    AnnualIncomeStatementBusiness,
    AnnualIncomeStatementIndividual,
    AnnualTotalsIndividual,
    AsynchronousAccepted202,
    BadRequestErrorBodyItem,
    Balance,
    BalancesPaginatedResponse,
    BalancesRequest,
    BankAccountBusinessPse,
    BankAccountDetailsOfpi,
    BankAccountDetailsOfpiPix,
    BankAccountDetailsOpenFinance,
    BankAccountDetailsOpenFinancePix,
    BankAccountHolderRequestOfpi,
    BankAccountHolderRequestOfpiInformation,
    BankAccountInformationContentPse,
    BankAccountInformationPse,
    BankAccountOfpiResponse,
    BankAccountOfpiResponseDetails,
    BankAccountPaginatedResponse,
    BankAccountPaginatedResponseResultsItem,
    BankAccountPseResponse,
    BeneficiaryBankAccountOfpi,
    BeneficiaryBankAccountOfpiDetails,
    BeneficiaryBankAccountPse,
    Categorization,
    CategorizationBody,
    CategorizationBodyRequest,
    CategorizationMerchantData,
    ChangeAccessMode,
    Charge,
    ChargePaymentMethodDetails,
    ChargePaymentMethodDetailsOfpi,
    ChargePaymentMethodDetailsOfpiContent,
    ChargePaymentMethodDetailsPse,
    ChargePaymentMethodDetailsPseContent,
    ChargeStatus,
    CreateBankAccountOfpi,
    CreateBankAccountOfpiDetails,
    CreateBankAccountPse,
    CreateBankAccountRequest,
    CreateBankAccountResponse,
    CreateCustomerOfpi,
    CreateCustomerPse,
    CreateCustomerRequest,
    CreateCustomerResponse,
    CreatePaymentIntentPse,
    CreatePaymentIntentPseAmount,
    CreatePaymentLinkOfpi,
    CreatePaymentLinkOfpiAmount,
    CreatePaymentLinkPse,
    CreatePaymentLinkPseAmount,
    CreatePaymentlinkRequest,
    CreatePaymentlinkResponse,
    CustomerOfpi,
    CustomerPaginatedResponse,
    CustomerPaginatedResponseResultsItem,
    CustomerPse,
    DetailBankAccountResponse,
    DetailCreatePaymentlinkResponse,
    DetailCustomerResponse,
    DetailInvoiceResponse,
    DetailTaxDeclarationResponse,
    DetailTaxReturnResponse,
    DetailTaxStatusResponse,
    DisplayConfirmationRequiredContentPse,
    DisplayConfirmationRequiredOfpi,
    DisplayCredentialsRequiredContentPse,
    DisplayCustomerBankAccountsContentPse,
    DisplayPaymentFailed,
    DisplayPaymentMethodInformationContentOfpi,
    DisplayPaymentMethodInformationContentPse,
    DisplayPaymentProcessing,
    DisplayPaymentSucceeded,
    DisplayTokenRequiredContentPse,
    DocumentIdBusiness,
    DocumentIdIndividual,
    DocumentInformationBusiness,
    DocumentInformationIndividual,
    EmploymentRecord,
    EmploymentRecordDetail,
    EmploymentRecordDocumentId,
    EmploymentRecordEmploymentStatusUpdates,
    EmploymentRecordEntitlement,
    EmploymentRecordFile,
    EmploymentRecordPersonalData,
    EmploymentRecordRequest,
    EmploymentRecordSocialSecuritySummary,
    EmploymentRecordsPaginatedResponse,
    EnumAccountCategory,
    EnumBankAccountHolderTypeOfpi,
    EnumBankAccountHolderTypePse,
    EnumBankAccountPixAccountTypeOfpi,
    EnumCategorizationAccountCategory,
    EnumCategorizationAccountHolderType,
    EnumCategorizationTransactionCategory,
    EnumCategorizationTransactionSubcategory,
    EnumCategorizationTransactionType,
    EnumCustomerIdentifierTypeOfpi,
    EnumCustomerIdentifierTypePse,
    EnumCustomerType,
    EnumEmploymentRecordDocumentType,
    EnumEmploymentRecordStatus,
    EnumEmploymentRecordStatusUpdateEvents,
    EnumIncomeMinimumConfidenceLevelRequest,
    EnumIncomeSourceType,
    EnumIncomeStreamConfidence,
    EnumIncomeStreamFrequency,
    EnumIncomeStreamType,
    EnumIncomeVerificationAccountCategory,
    EnumIncomeVerificationAccountHolderType,
    EnumIncomeVerificationType,
    EnumInstitutionIntegrationType,
    EnumInstitutionStatus,
    EnumInstitutionType,
    EnumInvestmentPortfolioInstrumentType,
    EnumInvestmentPortfolioType,
    EnumInvoiceAllowedIncomeTypesRequest,
    EnumInvoiceDianInvoiceType,
    EnumInvoiceDianPaymentMethod,
    EnumInvoiceSatInvoiceType,
    EnumInvoiceSatPaymentMethod,
    EnumInvoiceType,
    EnumLinkAccessModeRequest,
    EnumLinkAccessModeResponse,
    EnumLinkRefreshRate,
    EnumLinkStatus,
    EnumLoanDataFeeType,
    EnumLoanDataInterestRateType,
    EnumPaymentIntentHolderTypePse,
    EnumPaymentIntentStatus,
    EnumPaymentLinkAllowedPaymentMethod,
    EnumPaymentLinkProvider,
    EnumPaymentLinksStatus,
    EnumPaymentsCountry,
    EnumPaymentsCurrency,
    EnumPaymentTransactionType,
    EnumReceivableTransactionFeeType,
    EnumReceivableTransactionStatus,
    EnumReceivableTransactionType,
    EnumRecurringExpenseCategory,
    EnumRecurringExpenseFrequency,
    EnumRecurringExpensePaymentType,
    EnumTaxComplianceStatusOutcome,
    EnumTaxRetentionPaymentStatus,
    EnumTaxRetentionReceiverNationality,
    EnumTaxRetentionType,
    EnumTransactionBillStatus,
    EnumTransactionCategory,
    EnumTransactionStatus,
    EnumTransactionSubcategory,
    EnumTransactionType,
    EquityStatementBusiness,
    EquityStatementIndividual,
    EyodIncomeVerificationBodyRequest,
    GrossIncomeIndividual,
    HolderBankAccountInformationPse,
    HolderBankAccountPse,
    HolderBusinessPse,
    HolderBusinessResponsePse,
    HolderInformationBusinessOfpi,
    HolderInformationBusinessOfpiResponse,
    HolderInformationBusinessPse,
    HolderInformationBusinessPseResponse,
    HolderInformationIndividualOfpi,
    HolderInformationIndividualOfpiResponse,
    HolderResponseOfpi,
    HolderResponseOfpiInformation,
    Income,
    IncomesPaginatedResponse,
    IncomesRequest,
    IncomeStreamsBody,
    Institution,
    InstitutionAccount,
    InstitutionDownError,
    InstitutionFormField,
    InstitutionInactiveError,
    InstitutionsFeature,
    InstitutionsFormField,
    InstitutionsFormFieldValues,
    InstitutionsPaginatedResponse,
    InstitutionUnavailableError,
    InvalidAccessMode,
    InvalidLinkError,
    InvalidPeriodError,
    InvestmentsPortfolio,
    InvestmentsPortfolioInstrument,
    InvestmentsPortfolioInstrumentFees,
    InvestmentsPortfolioInstrumentInterestRate,
    InvestmentsPortfolioInstrumentPublicId,
    InvestmentsPortfolioInstrumentRedemptionConditions,
    InvestmentsPortfoliosPaginatedResponse,
    InvoiceDetailDian,
    InvoiceDetailRetainedTaxSat,
    InvoiceDetailSat,
    InvoiceDian,
    InvoiceSenderDetailsDian,
    InvoicesPaymentsDian,
    InvoicesPaymentsRelatedDocumentsDian,
    InvoicesPaymentsRelatedDocumentsSat,
    InvoicesPaymentsSat,
    InvoicesPayrollDian,
    InvoicesPayrollSat,
    InvoicesReceiverDetailsDian,
    InvoicesRequest,
    InvoicesResponsePaginatedResponse,
    InvoicesResponsePaginatedResponseResultsItem,
    InvoiceWarningsDian,
    InvoiceWarningsSat,
    InvoiceWithIdSat,
    LastErrorInvalidCredentials,
    LastErrorInvalidToken,
    LastErrorLoginError,
    LastErrorPaymentError,
    LastErrorSessionExpired,
    LastErrorTwoFactor,
    Link,
    LinksPutRequest,
    LinksRequest,
    ListPaymentLinksRequestOrdering,
    ListPaymentLinksRequestStatus,
    ListTaxDeclarationsResponse,
    ListTaxReturnsResponse,
    LoginError,
    NeedsRedirectContent,
    NeedsRedirectContentPse,
    NetIncomeIndividual,
    NextStepDisplayConfirmationRequiredOfpi,
    NextStepDisplayConfirmationRequiredOfpiType,
    NextStepDisplayConfirmationRequiredPse,
    NextStepDisplayConfirmationRequiredPseType,
    NextStepDisplayCredentialsRequiredPse,
    NextStepDisplayCredentialsRequiredPseType,
    NextStepDisplayCustomerBankAccountsPse,
    NextStepDisplayCustomerBankAccountsPseType,
    NextStepDisplayNeedsRedirectPse,
    NextStepDisplayNeedsRedirectPseType,
    NextStepDisplayPaymentFailed,
    NextStepDisplayPaymentFailedType,
    NextStepDisplayPaymentMethodInformation,
    NextStepDisplayPaymentMethodInformationPse,
    NextStepDisplayPaymentMethodInformationPseType,
    NextStepDisplayPaymentMethodInformationType,
    NextStepDisplayPaymentProcessing,
    NextStepDisplayPaymentProcessingType,
    NextStepDisplayPaymentSucceeded,
    NextStepDisplayPaymentSucceededType,
    NextStepDisplayTokenRequiredPse,
    NextStepDisplayTokenRequiredPseType,
    NextStepNeedsRedirect,
    NextStepNeedsRedirectType,
    NonTaxableIncomeIndividual,
    NotFoundErrorBody,
    Owner,
    OwnerDocumentId,
    OwnersPaginatedResponse,
    PaginatedResponseLink,
    PatchBody,
    PatchBodyWithoutSaveData,
    PatchInvoicesResponseItem,
    PatchPaymentIntentsBodyPse,
    PatchPaymentMethodDetailsPse,
    PaymentInstitution,
    PaymentIntentOfpi,
    PaymentIntentOfpiNextStep,
    PaymentIntentOfpiPaymentMethodDetails,
    PaymentIntentPaginatedResponse,
    PaymentIntentPaymentMethodDetailsBodyBusinessOfpi,
    PaymentIntentPaymentMethodDetailsBodyIndividualOfpi,
    PaymentIntentPaymentMethodDetailsBodyPse,
    PaymentIntentPaymentMethodDetailsBusinessOfpi,
    PaymentIntentPaymentMethodDetailsIndividualOfpi,
    PaymentIntentPaymentMethodDetailsPse,
    PaymentIntentPse,
    PaymentIntentPseLastError,
    PaymentIntentPseNextStep,
    PaymentIntentsPaymentMethodDetailsBodyPse,
    PaymentIntentsPaymentMethodDetailsPse,
    PaymentLinkCallbackUrls,
    PaymentLinkCallbackUrlsResponse,
    PaymentLinkListOfpi,
    PaymentLinkListPse,
    PaymentLinkOfpi,
    PaymentLinkPaginatedResponse,
    PaymentLinkPaginatedResponseResultsItem,
    PaymentLinkPse,
    PaymentLinksPaymentMethodDetailsBodyOfpi,
    PaymentLinksPaymentMethodDetailsBodyPse,
    PaymentMethodDetailsOfpi,
    PaymentMethodDetailsPse,
    PaymentMethodInfoCustomerBankAccountsPse,
    PaymentMethodInformationBodyOfpi,
    PaymentMethodInformationBodyPse,
    PaymentMethodInformationDetailsPse,
    PaymentMethodInformationOfpi,
    PaymentMethodInformationPse,
    PaymentsInstitutionsPaginatedResponse,
    PaymentsTransactionsPaginatedResponse,
    PaymentsWay,
    PaymentsWebhooksPaginatedResponse,
    PaymentTransaction,
    PaymentTransactionPayer,
    PaymentWebhook,
    PensionIncomeStatementIndividual,
    ProvidersPse,
    ReceivablesTransaction,
    ReceivablesTransactionAccount,
    ReceivablesTransactionNumberOfInstallments,
    ReceivablesTransactionsPaginatedResponse,
    ReceivableTransactionRequest,
    RecevablesTransactionFees,
    RecurringExpenses,
    RecurringExpenseSourceTransaction,
    RecurringExpensesPaginatedResponse,
    RecurringExpensesRequest,
    ReportingId,
    RequestTimeoutErrorBody,
    RetentionBreakdown,
    RetrieveInvoicesResponseItem,
    RetrieveTaxDeclarationsResponseItem,
    RetrieveTaxReturnsRequestBody,
    RetrieveTaxReturnsResponseItem,
    RetrieveTaxStatusResponse,
    RiskInsights,
    RiskInsightsBalanceMetrics,
    RiskInsightsCashflowMetrics,
    RiskInsightsCreditCardMetrics,
    RiskInsightsLoansMetrics,
    RiskInsightsPaginatedResponse,
    RiskInsightsTransactionMetrics,
    SecretKeys,
    SecretKeysPaginatedResponse,
    SessionExpiredError,
    StandardRequest,
    TaxAssessmentBusiness,
    TaxAssessmentIndividual,
    TaxComplianceStatus,
    TaxComplianceStatusPaginatedResponse,
    TaxComplianceStatusRequest,
    TaxDeclarationBusiness,
    TaxDeclarationBusinessPaginated,
    TaxDeclarationIndividual,
    TaxDeclarationIndividualPaginated,
    TaxDeclarationsRequest,
    TaxPayerInformationBusiness,
    TaxPayerInformationIndividual,
    TaxRetentions,
    TaxRetentionsPaginatedResponse,
    TaxRetentionsRequest,
    TaxReturnBusiness,
    TaxReturnBusinessMonthly,
    TaxReturnPersonal,
    TaxReturnPersonalMonthly,
    TaxReturnsBusinessMonthlyPaginated,
    TaxReturnsBusinessPaginated,
    TaxReturnsMonthlyRequest,
    TaxReturnsPersonalMonthlyPaginated,
    TaxReturnsPersonalPaginated,
    TaxReturnsYearlyRequest,
    TaxStatusAddressBetweenStreetDian,
    TaxStatusAddressBetweenStreetSat,
    TaxStatusAddressDian,
    TaxStatusAddressSat,
    TaxStatusDian,
    TaxStatusEconomicActivityDian,
    TaxStatusEconomicActivitySat,
    TaxStatusObligationsDian,
    TaxStatusObligationsSat,
    TaxStatusPaginatedResponse,
    TaxStatusPaginatedResponseResultsItem,
    TaxStatusRegimensDian,
    TaxStatusRegimensSat,
    TaxStatusRequest,
    TaxStatusSat,
    TaxStatusTaxPayerInformationDian,
    TaxStatusTaxPayerInformationSat,
    TokenRequiredResponse,
    TokenRequiredResponseTokenGenerationData,
    TooManySessionsError,
    Transaction,
    TransactionBankAccountBodyPse,
    TransactionBankAccountOfpi,
    TransactionBankAccountPse,
    TransactionCreditCardData,
    TransactionMerchantData,
    TransactionsPaginatedResponse,
    TransactionsRequest,
    UnauthorizedErrorBody,
    UnconfirmedLinkError,
    UnexpectedError,
    UnsupportedOperationError,
    ValidationError,
)

__all__ = [
    "AccessToResourceDenied",
    "Account",
    "AccountsBalance",
    "AccountsCreditData",
    "AccountsFundsData",
    "AccountsFundsDataPublicIdentifications",
    "AccountsLoanData",
    "AccountsLoanDataFees",
    "AccountsLoanDataInterestRate",
    "AccountsPaginatedResponse",
    "AccountsReceivablesData",
    "AnnualCostsAndDeductionsStatementBusiness",
    "AnnualIncomeStatementBusiness",
    "AnnualIncomeStatementIndividual",
    "AnnualTotalsIndividual",
    "AsynchronousAccepted202",
    "BadRequestError",
    "BadRequestErrorBodyItem",
    "Balance",
    "BalancesPaginatedResponse",
    "BalancesRequest",
    "BankAccountBusinessPse",
    "BankAccountDetailsOfpi",
    "BankAccountDetailsOfpiPix",
    "BankAccountDetailsOpenFinance",
    "BankAccountDetailsOpenFinancePix",
    "BankAccountHolderRequestOfpi",
    "BankAccountHolderRequestOfpiInformation",
    "BankAccountInformationContentPse",
    "BankAccountInformationPse",
    "BankAccountOfpiResponse",
    "BankAccountOfpiResponseDetails",
    "BankAccountPaginatedResponse",
    "BankAccountPaginatedResponseResultsItem",
    "BankAccountPseResponse",
    "BelvoEnvironment",
    "BeneficiaryBankAccountOfpi",
    "BeneficiaryBankAccountOfpiDetails",
    "BeneficiaryBankAccountPse",
    "Categorization",
    "CategorizationBody",
    "CategorizationBodyRequest",
    "CategorizationMerchantData",
    "ChangeAccessMode",
    "Charge",
    "ChargePaymentMethodDetails",
    "ChargePaymentMethodDetailsOfpi",
    "ChargePaymentMethodDetailsOfpiContent",
    "ChargePaymentMethodDetailsPse",
    "ChargePaymentMethodDetailsPseContent",
    "ChargeStatus",
    "CreateBankAccountOfpi",
    "CreateBankAccountOfpiDetails",
    "CreateBankAccountPse",
    "CreateBankAccountRequest",
    "CreateBankAccountResponse",
    "CreateCustomerOfpi",
    "CreateCustomerPse",
    "CreateCustomerRequest",
    "CreateCustomerResponse",
    "CreatePaymentIntentPse",
    "CreatePaymentIntentPseAmount",
    "CreatePaymentLinkOfpi",
    "CreatePaymentLinkOfpiAmount",
    "CreatePaymentLinkPse",
    "CreatePaymentLinkPseAmount",
    "CreatePaymentlinkRequest",
    "CreatePaymentlinkResponse",
    "CustomerOfpi",
    "CustomerPaginatedResponse",
    "CustomerPaginatedResponseResultsItem",
    "CustomerPse",
    "DetailBankAccountResponse",
    "DetailCreatePaymentlinkResponse",
    "DetailCustomerResponse",
    "DetailInvoiceResponse",
    "DetailTaxDeclarationResponse",
    "DetailTaxReturnResponse",
    "DetailTaxStatusResponse",
    "DisplayConfirmationRequiredContentPse",
    "DisplayConfirmationRequiredOfpi",
    "DisplayCredentialsRequiredContentPse",
    "DisplayCustomerBankAccountsContentPse",
    "DisplayPaymentFailed",
    "DisplayPaymentMethodInformationContentOfpi",
    "DisplayPaymentMethodInformationContentPse",
    "DisplayPaymentProcessing",
    "DisplayPaymentSucceeded",
    "DisplayTokenRequiredContentPse",
    "DocumentIdBusiness",
    "DocumentIdIndividual",
    "DocumentInformationBusiness",
    "DocumentInformationIndividual",
    "EmploymentRecord",
    "EmploymentRecordDetail",
    "EmploymentRecordDocumentId",
    "EmploymentRecordEmploymentStatusUpdates",
    "EmploymentRecordEntitlement",
    "EmploymentRecordFile",
    "EmploymentRecordPersonalData",
    "EmploymentRecordRequest",
    "EmploymentRecordSocialSecuritySummary",
    "EmploymentRecordsPaginatedResponse",
    "EnumAccountCategory",
    "EnumBankAccountHolderTypeOfpi",
    "EnumBankAccountHolderTypePse",
    "EnumBankAccountPixAccountTypeOfpi",
    "EnumCategorizationAccountCategory",
    "EnumCategorizationAccountHolderType",
    "EnumCategorizationTransactionCategory",
    "EnumCategorizationTransactionSubcategory",
    "EnumCategorizationTransactionType",
    "EnumCustomerIdentifierTypeOfpi",
    "EnumCustomerIdentifierTypePse",
    "EnumCustomerType",
    "EnumEmploymentRecordDocumentType",
    "EnumEmploymentRecordStatus",
    "EnumEmploymentRecordStatusUpdateEvents",
    "EnumIncomeMinimumConfidenceLevelRequest",
    "EnumIncomeSourceType",
    "EnumIncomeStreamConfidence",
    "EnumIncomeStreamFrequency",
    "EnumIncomeStreamType",
    "EnumIncomeVerificationAccountCategory",
    "EnumIncomeVerificationAccountHolderType",
    "EnumIncomeVerificationType",
    "EnumInstitutionIntegrationType",
    "EnumInstitutionStatus",
    "EnumInstitutionType",
    "EnumInvestmentPortfolioInstrumentType",
    "EnumInvestmentPortfolioType",
    "EnumInvoiceAllowedIncomeTypesRequest",
    "EnumInvoiceDianInvoiceType",
    "EnumInvoiceDianPaymentMethod",
    "EnumInvoiceSatInvoiceType",
    "EnumInvoiceSatPaymentMethod",
    "EnumInvoiceType",
    "EnumLinkAccessModeRequest",
    "EnumLinkAccessModeResponse",
    "EnumLinkRefreshRate",
    "EnumLinkStatus",
    "EnumLoanDataFeeType",
    "EnumLoanDataInterestRateType",
    "EnumPaymentIntentHolderTypePse",
    "EnumPaymentIntentStatus",
    "EnumPaymentLinkAllowedPaymentMethod",
    "EnumPaymentLinkProvider",
    "EnumPaymentLinksStatus",
    "EnumPaymentTransactionType",
    "EnumPaymentsCountry",
    "EnumPaymentsCurrency",
    "EnumReceivableTransactionFeeType",
    "EnumReceivableTransactionStatus",
    "EnumReceivableTransactionType",
    "EnumRecurringExpenseCategory",
    "EnumRecurringExpenseFrequency",
    "EnumRecurringExpensePaymentType",
    "EnumTaxComplianceStatusOutcome",
    "EnumTaxRetentionPaymentStatus",
    "EnumTaxRetentionReceiverNationality",
    "EnumTaxRetentionType",
    "EnumTransactionBillStatus",
    "EnumTransactionCategory",
    "EnumTransactionStatus",
    "EnumTransactionSubcategory",
    "EnumTransactionType",
    "EquityStatementBusiness",
    "EquityStatementIndividual",
    "EyodIncomeVerificationBodyRequest",
    "ForbiddenError",
    "GrossIncomeIndividual",
    "HolderBankAccountInformationPse",
    "HolderBankAccountPse",
    "HolderBusinessPse",
    "HolderBusinessResponsePse",
    "HolderInformationBusinessOfpi",
    "HolderInformationBusinessOfpiResponse",
    "HolderInformationBusinessPse",
    "HolderInformationBusinessPseResponse",
    "HolderInformationIndividualOfpi",
    "HolderInformationIndividualOfpiResponse",
    "HolderResponseOfpi",
    "HolderResponseOfpiInformation",
    "Income",
    "IncomeStreamsBody",
    "IncomesPaginatedResponse",
    "IncomesRequest",
    "Institution",
    "InstitutionAccount",
    "InstitutionDownError",
    "InstitutionFormField",
    "InstitutionInactiveError",
    "InstitutionUnavailableError",
    "InstitutionsFeature",
    "InstitutionsFormField",
    "InstitutionsFormFieldValues",
    "InstitutionsPaginatedResponse",
    "InternalServerError",
    "InvalidAccessMode",
    "InvalidLinkError",
    "InvalidPeriodError",
    "InvestmentsPortfolio",
    "InvestmentsPortfolioInstrument",
    "InvestmentsPortfolioInstrumentFees",
    "InvestmentsPortfolioInstrumentInterestRate",
    "InvestmentsPortfolioInstrumentPublicId",
    "InvestmentsPortfolioInstrumentRedemptionConditions",
    "InvestmentsPortfoliosPaginatedResponse",
    "InvoiceDetailDian",
    "InvoiceDetailRetainedTaxSat",
    "InvoiceDetailSat",
    "InvoiceDian",
    "InvoiceSenderDetailsDian",
    "InvoiceWarningsDian",
    "InvoiceWarningsSat",
    "InvoiceWithIdSat",
    "InvoicesPaymentsDian",
    "InvoicesPaymentsRelatedDocumentsDian",
    "InvoicesPaymentsRelatedDocumentsSat",
    "InvoicesPaymentsSat",
    "InvoicesPayrollDian",
    "InvoicesPayrollSat",
    "InvoicesReceiverDetailsDian",
    "InvoicesRequest",
    "InvoicesResponsePaginatedResponse",
    "InvoicesResponsePaginatedResponseResultsItem",
    "LastErrorInvalidCredentials",
    "LastErrorInvalidToken",
    "LastErrorLoginError",
    "LastErrorPaymentError",
    "LastErrorSessionExpired",
    "LastErrorTwoFactor",
    "Link",
    "LinksPutRequest",
    "LinksRequest",
    "ListPaymentLinksRequestOrdering",
    "ListPaymentLinksRequestStatus",
    "ListTaxDeclarationsResponse",
    "ListTaxReturnsResponse",
    "LoginError",
    "NeedsRedirectContent",
    "NeedsRedirectContentPse",
    "NetIncomeIndividual",
    "NextStepDisplayConfirmationRequiredOfpi",
    "NextStepDisplayConfirmationRequiredOfpiType",
    "NextStepDisplayConfirmationRequiredPse",
    "NextStepDisplayConfirmationRequiredPseType",
    "NextStepDisplayCredentialsRequiredPse",
    "NextStepDisplayCredentialsRequiredPseType",
    "NextStepDisplayCustomerBankAccountsPse",
    "NextStepDisplayCustomerBankAccountsPseType",
    "NextStepDisplayNeedsRedirectPse",
    "NextStepDisplayNeedsRedirectPseType",
    "NextStepDisplayPaymentFailed",
    "NextStepDisplayPaymentFailedType",
    "NextStepDisplayPaymentMethodInformation",
    "NextStepDisplayPaymentMethodInformationPse",
    "NextStepDisplayPaymentMethodInformationPseType",
    "NextStepDisplayPaymentMethodInformationType",
    "NextStepDisplayPaymentProcessing",
    "NextStepDisplayPaymentProcessingType",
    "NextStepDisplayPaymentSucceeded",
    "NextStepDisplayPaymentSucceededType",
    "NextStepDisplayTokenRequiredPse",
    "NextStepDisplayTokenRequiredPseType",
    "NextStepNeedsRedirect",
    "NextStepNeedsRedirectType",
    "NonTaxableIncomeIndividual",
    "NotFoundError",
    "NotFoundErrorBody",
    "Owner",
    "OwnerDocumentId",
    "OwnersPaginatedResponse",
    "PaginatedResponseLink",
    "PatchBody",
    "PatchBodyWithoutSaveData",
    "PatchInvoicesResponseItem",
    "PatchPaymentIntentsBodyPse",
    "PatchPaymentMethodDetailsPse",
    "PaymentInstitution",
    "PaymentIntentOfpi",
    "PaymentIntentOfpiNextStep",
    "PaymentIntentOfpiPaymentMethodDetails",
    "PaymentIntentPaginatedResponse",
    "PaymentIntentPaymentMethodDetailsBodyBusinessOfpi",
    "PaymentIntentPaymentMethodDetailsBodyIndividualOfpi",
    "PaymentIntentPaymentMethodDetailsBodyPse",
    "PaymentIntentPaymentMethodDetailsBusinessOfpi",
    "PaymentIntentPaymentMethodDetailsIndividualOfpi",
    "PaymentIntentPaymentMethodDetailsPse",
    "PaymentIntentPse",
    "PaymentIntentPseLastError",
    "PaymentIntentPseNextStep",
    "PaymentIntentsPaymentMethodDetailsBodyPse",
    "PaymentIntentsPaymentMethodDetailsPse",
    "PaymentLinkCallbackUrls",
    "PaymentLinkCallbackUrlsResponse",
    "PaymentLinkListOfpi",
    "PaymentLinkListPse",
    "PaymentLinkOfpi",
    "PaymentLinkPaginatedResponse",
    "PaymentLinkPaginatedResponseResultsItem",
    "PaymentLinkPse",
    "PaymentLinksPaymentMethodDetailsBodyOfpi",
    "PaymentLinksPaymentMethodDetailsBodyPse",
    "PaymentMethodDetailsOfpi",
    "PaymentMethodDetailsPse",
    "PaymentMethodInfoCustomerBankAccountsPse",
    "PaymentMethodInformationBodyOfpi",
    "PaymentMethodInformationBodyPse",
    "PaymentMethodInformationDetailsPse",
    "PaymentMethodInformationOfpi",
    "PaymentMethodInformationPse",
    "PaymentTransaction",
    "PaymentTransactionPayer",
    "PaymentWebhook",
    "PaymentsInstitutionsPaginatedResponse",
    "PaymentsTransactionsPaginatedResponse",
    "PaymentsWay",
    "PaymentsWebhooksPaginatedResponse",
    "PensionIncomeStatementIndividual",
    "PreconditionError",
    "ProvidersPse",
    "ReceivableTransactionRequest",
    "ReceivablesTransaction",
    "ReceivablesTransactionAccount",
    "ReceivablesTransactionNumberOfInstallments",
    "ReceivablesTransactionsPaginatedResponse",
    "RecevablesTransactionFees",
    "RecurringExpenseSourceTransaction",
    "RecurringExpenses",
    "RecurringExpensesPaginatedResponse",
    "RecurringExpensesRequest",
    "ReportingId",
    "RequestTimeoutError",
    "RequestTimeoutErrorBody",
    "RetentionBreakdown",
    "RetrieveInvoicesResponseItem",
    "RetrieveTaxDeclarationsResponseItem",
    "RetrieveTaxReturnsRequestBody",
    "RetrieveTaxReturnsResponseItem",
    "RetrieveTaxStatusResponse",
    "RiskInsights",
    "RiskInsightsBalanceMetrics",
    "RiskInsightsCashflowMetrics",
    "RiskInsightsCreditCardMetrics",
    "RiskInsightsLoansMetrics",
    "RiskInsightsPaginatedResponse",
    "RiskInsightsTransactionMetrics",
    "SecretKeys",
    "SecretKeysPaginatedResponse",
    "SessionExpiredError",
    "StandardRequest",
    "TaxAssessmentBusiness",
    "TaxAssessmentIndividual",
    "TaxComplianceStatus",
    "TaxComplianceStatusPaginatedResponse",
    "TaxComplianceStatusRequest",
    "TaxDeclarationBusiness",
    "TaxDeclarationBusinessPaginated",
    "TaxDeclarationIndividual",
    "TaxDeclarationIndividualPaginated",
    "TaxDeclarationsRequest",
    "TaxPayerInformationBusiness",
    "TaxPayerInformationIndividual",
    "TaxRetentions",
    "TaxRetentionsPaginatedResponse",
    "TaxRetentionsRequest",
    "TaxReturnBusiness",
    "TaxReturnBusinessMonthly",
    "TaxReturnPersonal",
    "TaxReturnPersonalMonthly",
    "TaxReturnsBusinessMonthlyPaginated",
    "TaxReturnsBusinessPaginated",
    "TaxReturnsMonthlyRequest",
    "TaxReturnsPersonalMonthlyPaginated",
    "TaxReturnsPersonalPaginated",
    "TaxReturnsYearlyRequest",
    "TaxStatusAddressBetweenStreetDian",
    "TaxStatusAddressBetweenStreetSat",
    "TaxStatusAddressDian",
    "TaxStatusAddressSat",
    "TaxStatusDian",
    "TaxStatusEconomicActivityDian",
    "TaxStatusEconomicActivitySat",
    "TaxStatusObligationsDian",
    "TaxStatusObligationsSat",
    "TaxStatusPaginatedResponse",
    "TaxStatusPaginatedResponseResultsItem",
    "TaxStatusRegimensDian",
    "TaxStatusRegimensSat",
    "TaxStatusRequest",
    "TaxStatusSat",
    "TaxStatusTaxPayerInformationDian",
    "TaxStatusTaxPayerInformationSat",
    "TokenRequiredResponse",
    "TokenRequiredResponseTokenGenerationData",
    "TooManySessionsError",
    "Transaction",
    "TransactionBankAccountBodyPse",
    "TransactionBankAccountOfpi",
    "TransactionBankAccountPse",
    "TransactionCreditCardData",
    "TransactionMerchantData",
    "TransactionsPaginatedResponse",
    "TransactionsRequest",
    "UnauthorizedError",
    "UnauthorizedErrorBody",
    "UnconfirmedLinkError",
    "UnexpectedError",
    "UnsupportedOperationError",
    "ValidationError",
    "accounts",
    "balances",
    "bank_accounts",
    "categorization",
    "customers",
    "employment_records",
    "income_verification",
    "incomes",
    "institutions",
    "investment_portfolios",
    "invoices",
    "links",
    "owners",
    "payment_institutions",
    "payment_intents",
    "payment_links",
    "payment_transactions",
    "payment_webhooks",
    "receivable_transactions",
    "recurring_expenses",
    "risk_insights",
    "secret_keys",
    "tax_compliance_status",
    "tax_declarations",
    "tax_retentions",
    "tax_returns",
    "tax_status",
    "transactions",
]
