# This file was auto-generated by Fern from our API Definition.

from backports.cached_property import cached_property

from .environment import BelvoEnvironment
from .resources.accounts.client import AccountsClient, AsyncAccountsClient
from .resources.balances.client import AsyncBalancesClient, BalancesClient
from .resources.bank_accounts.client import AsyncBankAccountsClient, BankAccountsClient
from .resources.categorization.client import AsyncCategorizationClient, CategorizationClient
from .resources.customers.client import AsyncCustomersClient, CustomersClient
from .resources.employment_records.client import AsyncEmploymentRecordsClient, EmploymentRecordsClient
from .resources.income_verification.client import AsyncIncomeVerificationClient, IncomeVerificationClient
from .resources.incomes.client import AsyncIncomesClient, IncomesClient
from .resources.institutions.client import AsyncInstitutionsClient, InstitutionsClient
from .resources.investment_portfolios.client import AsyncInvestmentPortfoliosClient, InvestmentPortfoliosClient
from .resources.invoices.client import AsyncInvoicesClient, InvoicesClient
from .resources.links.client import AsyncLinksClient, LinksClient
from .resources.owners.client import AsyncOwnersClient, OwnersClient
from .resources.payment_institutions.client import AsyncPaymentInstitutionsClient, PaymentInstitutionsClient
from .resources.payment_intents.client import AsyncPaymentIntentsClient, PaymentIntentsClient
from .resources.payment_links.client import AsyncPaymentLinksClient, PaymentLinksClient
from .resources.payment_transactions.client import AsyncPaymentTransactionsClient, PaymentTransactionsClient
from .resources.payment_webhooks.client import AsyncPaymentWebhooksClient, PaymentWebhooksClient
from .resources.receivable_transactions.client import AsyncReceivableTransactionsClient, ReceivableTransactionsClient
from .resources.recurring_expenses.client import AsyncRecurringExpensesClient, RecurringExpensesClient
from .resources.risk_insights.client import AsyncRiskInsightsClient, RiskInsightsClient
from .resources.secret_keys.client import AsyncSecretKeysClient, SecretKeysClient
from .resources.tax_compliance_status.client import AsyncTaxComplianceStatusClient, TaxComplianceStatusClient
from .resources.tax_declarations.client import AsyncTaxDeclarationsClient, TaxDeclarationsClient
from .resources.tax_retentions.client import AsyncTaxRetentionsClient, TaxRetentionsClient
from .resources.tax_returns.client import AsyncTaxReturnsClient, TaxReturnsClient
from .resources.tax_status.client import AsyncTaxStatusClient, TaxStatusClient
from .resources.transactions.client import AsyncTransactionsClient, TransactionsClient


class Belvo:
    def __init__(self, *, environment: BelvoEnvironment = BelvoEnvironment.PRODUCTION, username: str, password: str):
        self._environment = environment
        self._username = username
        self._password = password

    @cached_property
    def links(self) -> LinksClient:
        return LinksClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def accounts(self) -> AccountsClient:
        return AccountsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def transactions(self) -> TransactionsClient:
        return TransactionsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def balances(self) -> BalancesClient:
        return BalancesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def institutions(self) -> InstitutionsClient:
        return InstitutionsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def owners(self) -> OwnersClient:
        return OwnersClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def invoices(self) -> InvoicesClient:
        return InvoicesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_returns(self) -> TaxReturnsClient:
        return TaxReturnsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_status(self) -> TaxStatusClient:
        return TaxStatusClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_compliance_status(self) -> TaxComplianceStatusClient:
        return TaxComplianceStatusClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def incomes(self) -> IncomesClient:
        return IncomesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def recurring_expenses(self) -> RecurringExpensesClient:
        return RecurringExpensesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def investment_portfolios(self) -> InvestmentPortfoliosClient:
        return InvestmentPortfoliosClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def receivable_transactions(self) -> ReceivableTransactionsClient:
        return ReceivableTransactionsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def risk_insights(self) -> RiskInsightsClient:
        return RiskInsightsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_retentions(self) -> TaxRetentionsClient:
        return TaxRetentionsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_declarations(self) -> TaxDeclarationsClient:
        return TaxDeclarationsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def employment_records(self) -> EmploymentRecordsClient:
        return EmploymentRecordsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def income_verification(self) -> IncomeVerificationClient:
        return IncomeVerificationClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def categorization(self) -> CategorizationClient:
        return CategorizationClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def secret_keys(self) -> SecretKeysClient:
        return SecretKeysClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_webhooks(self) -> PaymentWebhooksClient:
        return PaymentWebhooksClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_institutions(self) -> PaymentInstitutionsClient:
        return PaymentInstitutionsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def customers(self) -> CustomersClient:
        return CustomersClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def bank_accounts(self) -> BankAccountsClient:
        return BankAccountsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_links(self) -> PaymentLinksClient:
        return PaymentLinksClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_intents(self) -> PaymentIntentsClient:
        return PaymentIntentsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_transactions(self) -> PaymentTransactionsClient:
        return PaymentTransactionsClient(
            environment=self._environment, username=self._username, password=self._password
        )


class AsyncBelvo:
    def __init__(self, *, environment: BelvoEnvironment = BelvoEnvironment.PRODUCTION, username: str, password: str):
        self._environment = environment
        self._username = username
        self._password = password

    @cached_property
    def links(self) -> AsyncLinksClient:
        return AsyncLinksClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def accounts(self) -> AsyncAccountsClient:
        return AsyncAccountsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def transactions(self) -> AsyncTransactionsClient:
        return AsyncTransactionsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def balances(self) -> AsyncBalancesClient:
        return AsyncBalancesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def institutions(self) -> AsyncInstitutionsClient:
        return AsyncInstitutionsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def owners(self) -> AsyncOwnersClient:
        return AsyncOwnersClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def invoices(self) -> AsyncInvoicesClient:
        return AsyncInvoicesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_returns(self) -> AsyncTaxReturnsClient:
        return AsyncTaxReturnsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_status(self) -> AsyncTaxStatusClient:
        return AsyncTaxStatusClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_compliance_status(self) -> AsyncTaxComplianceStatusClient:
        return AsyncTaxComplianceStatusClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def incomes(self) -> AsyncIncomesClient:
        return AsyncIncomesClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def recurring_expenses(self) -> AsyncRecurringExpensesClient:
        return AsyncRecurringExpensesClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def investment_portfolios(self) -> AsyncInvestmentPortfoliosClient:
        return AsyncInvestmentPortfoliosClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def receivable_transactions(self) -> AsyncReceivableTransactionsClient:
        return AsyncReceivableTransactionsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def risk_insights(self) -> AsyncRiskInsightsClient:
        return AsyncRiskInsightsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_retentions(self) -> AsyncTaxRetentionsClient:
        return AsyncTaxRetentionsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def tax_declarations(self) -> AsyncTaxDeclarationsClient:
        return AsyncTaxDeclarationsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def employment_records(self) -> AsyncEmploymentRecordsClient:
        return AsyncEmploymentRecordsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def income_verification(self) -> AsyncIncomeVerificationClient:
        return AsyncIncomeVerificationClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def categorization(self) -> AsyncCategorizationClient:
        return AsyncCategorizationClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def secret_keys(self) -> AsyncSecretKeysClient:
        return AsyncSecretKeysClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_webhooks(self) -> AsyncPaymentWebhooksClient:
        return AsyncPaymentWebhooksClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def payment_institutions(self) -> AsyncPaymentInstitutionsClient:
        return AsyncPaymentInstitutionsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def customers(self) -> AsyncCustomersClient:
        return AsyncCustomersClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def bank_accounts(self) -> AsyncBankAccountsClient:
        return AsyncBankAccountsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_links(self) -> AsyncPaymentLinksClient:
        return AsyncPaymentLinksClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def payment_intents(self) -> AsyncPaymentIntentsClient:
        return AsyncPaymentIntentsClient(
            environment=self._environment, username=self._username, password=self._password
        )

    @cached_property
    def payment_transactions(self) -> AsyncPaymentTransactionsClient:
        return AsyncPaymentTransactionsClient(
            environment=self._environment, username=self._username, password=self._password
        )
