# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class AccountsReceivablesData(pydantic.BaseModel):
    current: typing.Optional[float] = pydantic.Field(
        description=("The total sum of all receivables (`available` + `anticipated`)\n")
    )
    available: typing.Optional[float] = pydantic.Field(
        description=("The amount that the owner of the account will receive according to an established date.\n")
    )
    anticipated: typing.Optional[float] = pydantic.Field(
        description=("The amount that the owner of the account received earlier than contracted.\n")
    )
    collected_at: str = pydantic.Field(description=("The ISO-8601 timestamp when the data point was collected.\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
