# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .enum_categorization_account_category import EnumCategorizationAccountCategory
from .enum_categorization_account_holder_type import EnumCategorizationAccountHolderType
from .enum_categorization_transaction_type import EnumCategorizationTransactionType


class CategorizationBodyRequest(pydantic.BaseModel):
    transaction_id: str = pydantic.Field(description=("Your unique ID for the transaction.\n"))
    account_holder_type: EnumCategorizationAccountHolderType
    account_holder_id: str = pydantic.Field(description=("Your unique ID for the account holder.\n"))
    account_id: str = pydantic.Field(description=("Your unique ID for the account where the transaction occurred.\n"))
    account_category: EnumCategorizationAccountCategory
    value_date: str = pydantic.Field(description=("The date when the transaction occurred, in `YYYY-MM-DD` format.\n"))
    description: str = pydantic.Field(description=("The description of the transaction.\n"))
    type: EnumCategorizationTransactionType
    amount: float = pydantic.Field(description=("The transaction amount.\n"))
    currency: str = pydantic.Field(
        description=(
            "The currency of the account, in ISO-4217 format. For example: - 🇧🇷 BRL (Brazilian Real) - 🇨🇴 COP (Colombian Peso) - 🇲🇽 MXN (Mexican Peso)\n"
        )
    )
    institution: str = pydantic.Field(
        description=(
            "The institution where the account is registered.\n"
            "\n"
            ">**Note:** This is the name that you use in your system to identify an institution.\n"
        )
    )
    mcc: typing.Optional[int] = pydantic.Field(
        description=(
            "The four-digit ISO 18245 Merchant Category Code (MCC). Only required when `account_category` = `CREDIT_CARD`.\n"
        )
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
