# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class ChargePaymentMethodDetailsOfpiContent(pydantic.BaseModel):
    """
    Information about the payer of a PSE payment.
    """

    payer_institution: typing.Optional[str] = pydantic.Field(
        description=("Unique identifier for the payer’s institution.\n")
    )
    beneficiary_bank_account: typing.Optional[str] = pydantic.Field(
        description=("Belvo's unique ID used to identify the beneficiary's bank account.\n")
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
