# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .bank_account_holder_request_ofpi import BankAccountHolderRequestOfpi
from .create_bank_account_ofpi_details import CreateBankAccountOfpiDetails


class CreateBankAccountOfpi(pydantic.BaseModel):
    institution: str = pydantic.Field(
        description=("Belvo's unique ID for the institution that the bank account is created in.\n")
    )
    holder: BankAccountHolderRequestOfpi = pydantic.Field(
        description=("Information regarding the individual bank account holder.\n")
    )
    details: CreateBankAccountOfpiDetails = pydantic.Field(description=("Information regarding the bank account.\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
