# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumCategorizationAccountCategory(str, enum.Enum):
    """
    The type of account.
    Can be either:
      - `CHECKING_ACCOUNT`
      - `CREDIT_CARD`
      - `LOAN_ACCOUNT`
      - `SAVINGS_ACCOUNT`
    """

    CHECKING_ACCOUNT = "CHECKING_ACCOUNT"
    CREDIT_CARD = "CREDIT_CARD"
    LOAN_ACCOUNT = "LOAN_ACCOUNT"
    SAVINGS_ACCOUNT = "SAVINGS_ACCOUNT"

    def visit(
        self,
        checking_account: typing.Callable[[], T_Result],
        credit_card: typing.Callable[[], T_Result],
        loan_account: typing.Callable[[], T_Result],
        savings_account: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is EnumCategorizationAccountCategory.CHECKING_ACCOUNT:
            return checking_account()
        if self is EnumCategorizationAccountCategory.CREDIT_CARD:
            return credit_card()
        if self is EnumCategorizationAccountCategory.LOAN_ACCOUNT:
            return loan_account()
        if self is EnumCategorizationAccountCategory.SAVINGS_ACCOUNT:
            return savings_account()
