# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumCategorizationTransactionType(str, enum.Enum):
    """
    The direction of the transaction.
    Can be either:

      - `INFLOW` indicates a received transaction.
      - `OUTFLOW` indicates a sent transaction.
    """

    INFLOW = "INFLOW"
    OUTFLOW = "OUTFLOW"

    def visit(self, inflow: typing.Callable[[], T_Result], outflow: typing.Callable[[], T_Result]) -> T_Result:
        if self is EnumCategorizationTransactionType.INFLOW:
            return inflow()
        if self is EnumCategorizationTransactionType.OUTFLOW:
            return outflow()
