# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumIncomeStreamConfidence(str, enum.Enum):
    """
    Belvo's level of confidence for future incomes.

    We return one of the following enum values:

      - `HIGH`
      - `MEDIUM`
      - `LOW`
    """

    HIGH = "HIGH"
    MEDIUM = "MEDIUM"
    LOW = "LOW"

    def visit(
        self,
        high: typing.Callable[[], T_Result],
        medium: typing.Callable[[], T_Result],
        low: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is EnumIncomeStreamConfidence.HIGH:
            return high()
        if self is EnumIncomeStreamConfidence.MEDIUM:
            return medium()
        if self is EnumIncomeStreamConfidence.LOW:
            return low()
