# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumInstitutionType(str, enum.Enum):
    """
    The type of institution. We return one of the following values:

      - `bank`
      - `fiscal`
      - `employment`
    """

    BANK = "bank"
    FISCAL = "fiscal"
    EMPLOYMENT = "employment"

    def visit(
        self,
        bank: typing.Callable[[], T_Result],
        fiscal: typing.Callable[[], T_Result],
        employment: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is EnumInstitutionType.BANK:
            return bank()
        if self is EnumInstitutionType.FISCAL:
            return fiscal()
        if self is EnumInstitutionType.EMPLOYMENT:
            return employment()
