# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumLoanDataFeeType(str, enum.Enum):
    """
    The type of fee. We return one of the following values:

      - `OPERATION_FEE`
      - `INSURANCE_FEE`
      - `OTHERS`
    """

    OPERATION_FEE = "OPERATION_FEE"
    INSURANCE_FEE = "INSURANCE_FEE"
    OTHERS = "OTHERS"

    def visit(
        self,
        operation_fee: typing.Callable[[], T_Result],
        insurance_fee: typing.Callable[[], T_Result],
        others: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is EnumLoanDataFeeType.OPERATION_FEE:
            return operation_fee()
        if self is EnumLoanDataFeeType.INSURANCE_FEE:
            return insurance_fee()
        if self is EnumLoanDataFeeType.OTHERS:
            return others()
