# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumPaymentLinkProvider(str, enum.Enum):
    """
    The provider used for the payment link.


    - For 🇧🇷 Brazil's OFPI, the value must be `belvo`.
    - For 🇨🇴 Colombia's PSE, the value must be `payments_way`.
    """

    BELVO = "belvo"
    PAYMENTS_WAY = "payments_way"

    def visit(self, belvo: typing.Callable[[], T_Result], payments_way: typing.Callable[[], T_Result]) -> T_Result:
        if self is EnumPaymentLinkProvider.BELVO:
            return belvo()
        if self is EnumPaymentLinkProvider.PAYMENTS_WAY:
            return payments_way()
