# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumPaymentLinksStatus(str, enum.Enum):
    """
    The current status of the payment link. Can be either:

      - `ACTIVE` meaning that the payment intent's status is either `REQUIRES_PAYMENT_METHOD`, `REQUIRES_ACTION`, or `PROCESSING`.
      - `INACTIVE` meaning that the payment intent's status is either `SUCCEEDED` or `FAILED`.

    **Note:** You can retrieve the complete payment intent by using our [Get details of a payment link](https://developers.belvo.com/reference/detailcreatepaymentlink) request.
    """

    ACTIVE = "ACTIVE"
    INACTIVE = "INACTIVE"

    def visit(self, active: typing.Callable[[], T_Result], inactive: typing.Callable[[], T_Result]) -> T_Result:
        if self is EnumPaymentLinksStatus.ACTIVE:
            return active()
        if self is EnumPaymentLinksStatus.INACTIVE:
            return inactive()
