# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class EnumPaymentTransactionType(str, enum.Enum):
    """
    The direction of the transaction.

      - `INFLOW` indicates money coming into the account.
      - `OUTFLOW` indicates money coming out of the account.
    """

    INFLOW = "INFLOW"
    OUTFLOW = "OUTFLOW"

    def visit(self, inflow: typing.Callable[[], T_Result], outflow: typing.Callable[[], T_Result]) -> T_Result:
        if self is EnumPaymentTransactionType.INFLOW:
            return inflow()
        if self is EnumPaymentTransactionType.OUTFLOW:
            return outflow()
