# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class EquityStatementIndividual(pydantic.BaseModel):
    """
    Object containing the general fiscal situation of the taxpayer.
    """

    total_gross_equity: float = pydantic.Field(description=("The total gross equity of the tax payer.\n"))
    total_debts: float = pydantic.Field(description=("The total debts of the tax_payer\n"))
    total_net_equity: float = pydantic.Field(description=("The total net equity value of the taxpayer.\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
