# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .institutions_form_field_values import InstitutionsFormFieldValues


class InstitutionFormField(pydantic.BaseModel):
    name: typing.Optional[str] = pydantic.Field(description=("The username, password, or username type field.\n"))
    type: typing.Optional[str] = pydantic.Field(
        description=("The input type for the form field. For example, string.\n")
    )
    label: typing.Optional[str] = pydantic.Field(
        description=("The label of the form field. For example:\n" "- Document\n" "- Clave\n" "- Token\n")
    )
    validation: typing.Optional[str] = pydantic.Field(
        description=("The type of input validation used for the field.\n")
    )
    placeholder: typing.Optional[str] = pydantic.Field(description=("The placeholder text in the form field.\n"))
    validation_message: typing.Optional[str] = pydantic.Field(
        description=("The message displayed when an invalid input is provided in the form field.\n")
    )
    values: typing.Optional[typing.List[InstitutionsFormFieldValues]] = pydantic.Field(
        description=("Array of additional form field values.\n")
    )
    length: typing.Optional[int] = pydantic.Field(description=("Number of digits allowed when the type is `token`.\n"))
    optional: typing.Optional[bool] = pydantic.Field(
        description=("It indicates whether this form field is optional.\n")
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
