# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .institutions_form_field_values import InstitutionsFormFieldValues


class InstitutionsFormField(pydantic.BaseModel):
    name: typing.Optional[str] = pydantic.Field(description=("The username, password, or username type field.\n"))
    type: typing.Optional[str] = pydantic.Field(
        description=("The input type for the form field. For example, string.\n")
    )
    label: typing.Optional[str] = pydantic.Field(
        description=(
            "The label of the form field. For example:\n" "- Client number\n" "- Key Bancanet\n" "- Document\n"
        )
    )
    validation: typing.Optional[str] = pydantic.Field(
        description=("The type of input validation used for the field.\n")
    )
    placeholder: typing.Optional[str] = pydantic.Field(description=("The placeholder text in the form field.\n"))
    validation_message: typing.Optional[str] = pydantic.Field(
        description=("The message displayed when an invalid input is provided in the form field.\n")
    )
    values: typing.Optional[typing.List[InstitutionsFormFieldValues]] = pydantic.Field(
        description=(
            "If the form field is for documents, the institution may require additional input regarding the document type.\n"
        )
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
