# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class PaymentIntentPaymentMethodDetailsBodyIndividualOfpi(pydantic.BaseModel):
    """
    Payment method type selected.
    """

    beneficiary_bank_account: str = pydantic.Field(
        description=("Belvo's unique ID used to identify the beneficiary's bank account.\n")
    )
    payer_institution: str = pydantic.Field(description=("Belvo's unique ID to reference the payer's institution.\n"))
    callback_url: str = pydantic.Field(
        description=(
            "The callback URL that your user will be redirected to after confirming the payment in their banking application.\n"
        )
    )
    cpf: typing.Optional[str] = pydantic.Field(
        description=(
            "The customer's CPF number. Only required when the `customer_type` is `BUSINESS`.\n"
            "\n"
            "**Note:** This value is obfuscated.\n"
        )
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
