# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class RiskInsightsLoansMetrics(pydantic.BaseModel):
    num_accounts: int = pydantic.Field(description=("Number of loan accounts associated with the link.\n"))
    sum_loans_principal: typing.Optional[float] = pydantic.Field(
        description=("Sum total of the principal for all of the link's loan accounts.\n")
    )
    sum_loans_outstanding_principal: typing.Optional[float] = pydantic.Field(
        description=("Sum total of the outstanding principal for all the link's loan accounts.\n")
    )
    sum_loans_monthly_payment: typing.Optional[float] = pydantic.Field(
        description=("Sum total of the monthly payments for all the link's loan accounts.\n")
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
