# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .annual_costs_and_deductions_statement_business import AnnualCostsAndDeductionsStatementBusiness
from .annual_income_statement_business import AnnualIncomeStatementBusiness
from .document_information_business import DocumentInformationBusiness
from .equity_statement_business import EquityStatementBusiness
from .tax_assessment_business import TaxAssessmentBusiness
from .tax_payer_information_business import TaxPayerInformationBusiness


class TaxDeclarationBusiness(pydantic.BaseModel):
    id: str = pydantic.Field(description=("Belvo's unique ID for the current tax declaration.\n"))
    link: str = pydantic.Field(
        description=("Belvo's unique ID of the user that this tax declaration is associated with.\n")
    )
    collected_at: str = pydantic.Field(description=("The ISO-8601 timestamp when the data point was collected.\n"))
    created_at: str = pydantic.Field(
        description=("The ISO-8601 timestamp of when the data point was last updated in Belvo's database.\n")
    )
    document_information: DocumentInformationBusiness
    tax_payer_information: TaxPayerInformationBusiness
    equity_statement: EquityStatementBusiness
    annual_income_statement: AnnualIncomeStatementBusiness
    annual_costs_and_deductions_statement: AnnualCostsAndDeductionsStatementBusiness
    tax_assessment: TaxAssessmentBusiness
    date_issued: str = pydantic.Field(
        description=("The date the tax declaration was issued by the fiscal institution.\n")
    )
    pdf: typing.Optional[str] = pydantic.Field(description=("The PDF of the tax declaration, as a binary string.\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
